# -*- coding: utf-8 -*-
"""Holidays assignment.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1ThftfxFRJXIuu9skmAvS3NKKJVEPHliD
"""

#1
class Counter:
    def __init__(self):
        self.value = 0

    def increment(self):
        self.value += 1

    def reset(self):
        self.value = 0
# Create an instance of the Counter class
my_counter = Counter()

# Print the initial value
print(my_counter.value)  

# Increment the counter
my_counter.increment()

# Print the updated value
print(my_counter.value)  

# Reset the counter
my_counter.reset()

# Print the reset value
print(my_counter.value)

#2
class Calculator:
    def add(self, a, b):
        return a + b

    def subtract(self, a, b):
        return a - b

    def multiply(self, a, b):
        return a * b

    def divide(self, a, b):
        if b != 0:
            return a / b
        else:
            raise ValueError("Cannot divide by zero.")

# Create an instance of the Calculator class
my_calculator = Calculator()

# Perform addition
result = my_calculator.add(5, 3)
print(result)  

# Perform subtraction
result = my_calculator.subtract(7, 2)
print(result)  

# Perform multiplication
result = my_calculator.multiply(4, 6)
print(result)  

# Perform division
result = my_calculator.divide(10, 2)
print(result)

class Person:
    count = 0

    def __init__(self, name, age):
        self.name = name
        self.age = age
        Person.count += 1
# Create instances of the Person class
person1 = Person("Alice", 25)
person2 = Person("Bob", 30)
person3 = Person("Charlie", 35)

# Print the value of the count class attribute
print(Person.count)

#4.Define a class BankAccount with instance attributes account_number and balance. Add a class attribute interest_rate that is set to 0.02. Add methods deposit and withdraw to modify the balance. Add a class method get_interest_rate that returns the value of the interest_rate attribute.
class BankAccount:
    
    def __init__(self,accountNumber, name, balance):
        self.accountNumber = accountNumber
        self.name = name
        self.balance = balance
        
    
    def Deposit(self , d ):
        self.balance = self.balance + d
    
    
    def Withdrawal(self , w):
        if(self.balance < w):
            print("impossible operation! Insufficient balance !")
        else:
            self.balance = self.balance - w
  
    def bankFees(self):
        self.balance = (95/100)*self.balance
        
    
    def display(self):
        print("Account Number : " , self.accountNumber)
        print("Account Name : " , self.name)
        print("Account Balance : " , self.balance , "/-")
        

newAccount = BankAccount(2178514584, "Black Widow" , 2700)

newAccount.Withdrawal(300)

newAccount.Deposit(200)

newAccount.display()

#5.Create a class Triangle with instance attributes side1, side2, and side3. Add a method is_equilateral that returns True if the triangle is equilateral (all sides are equal) and False otherwise. Create instances of Triangle and test the is_equilateral method.

class Triangle:
  side1=None
  side2=None
  side3=None

  def __init__(self,side1,side2,side3):
    self.side1=side1
    self.side2=side2
    self.side3=side3

  def is_equilateral(self):
    return self.side1==self.side2==self.side3

triangle1=Triangle(5,5,5)
print(triangle1.is_equilateral())

triangle2=Triangle(3,4,5)
print(triangle2.is_equilateral())

#6.Create a class called Rectangle that has two attributes width and height and two methods area() and perimeter(). Implement these methods to calculate the area and perimeter of a rectangle. Then, create another class called Square that inherits from Rectangle and has a single attribute side. Override the init() method to set the width and height to be equal to side. Implement the methods to calculate the area and perimeter of a square.
class Rectangle:
  def __init__(self,width,height):
    self.width=width
    self.height=height
  def area(self):
    return self.width*self.height
  def perimeter(self):
    return 2*(self.width+self.height)

class Square(Rectangle):
  def __init__(self,side):
    super().__init__(side,side)
    
rectangle=Rectangle(5,4)
print(rectangle.area())
print(rectangle.perimeter())

square=Square(5)
print(square.area())
print(square.perimeter())

#7.Create a class called Employee that has two attributes name and salary. Implement a method called calculate_bonus() that calculates the bonus of an employee based on their salary. Then, create two classes called Manager and Developer that inherit from Employee. Override the calculate_bonus() method for both classes to calculate the bonus based on a different percentage for each class.
class Employee:
  def __init__(self,name,salary):
    self.name=name
    self.salary=salary

  def calculate_bonus(self):
    return 0.1*self.salary

class Manager(Employee):
  def calculate_bonus(self):
    return 0.15*self.salary

class Developer(Employee):
  def calculate_bonus(self):
    return 0.12*self.salary

employee=Employee("Peter",5000)
print(employee.calculate_bonus())

manager=Manager("Parker",8000)
print(manager.calculate_bonus())

developer=Developer("Spidey",6000)
print(developer.calculate_bonus())

#Difficulty level

#1
#SALES PERSON
class Salesperson:
    def __init__(self, name):
        self.name = name
        self.record = {}
        self.value = 0.0

    def get_name(self):
        return self.name

    def buy_pro(self, product_name, market_price, quantity):
        if product_name in self.record:
            self.record[product_name][1] += quantity
        else:
            self.record[product_name] = [market_price, quantity]
        self.value -= market_price * quantity

    def sell_pro(self, product_name, market_price, quantity):
        if product_name in self.record:
            cost, stock = self.record[product_name]
            if stock >= quantity:
                self.record[product_name][1] -= quantity
                self.value += market_price * quantity
                if stock - quantity == 0:
                    del self.record[product_name]
            else:
                print(f"Not enough stock for {product_name}.")
        else:
            print(f"{product_name} is not in the record.")

    def get_record(self):
        return self.record

    def get_value(self):
        return self.value

salesperson = Salesperson("ram")


print(salesperson.get_name()) 


salesperson.buy_pro("Mjolnior", 1.0, 50)
salesperson.buy_pro("Storm Breaker", 0.8, 30)


salesperson.sell_pro("Mjolnior", 1.2, 20)
salesperson.sell_pro("Storm Breaker", 0.9, 40)  

print(salesperson.get_record())

print(salesperson.get_value())

#2
class Records:
    def __init__(self, filename):
        self.records_dict = {}
        self.gpa_scale = {
            'A+': 4.3,
            'A': 4.0,
            'A-': 3.7,
            'B+': 3.3,
            'B': 3.0,
            'B-': 2.7,
            'C+': 2.3,
            'C': 2.0,
            'C-': 1.7,
            'D+': 1.3,
            'D': 1.0,
            'D-': 0.7,
            'F': 0.0
        }

        self.load_records(filename)

    def load_records(self, filename):
        try:
            with open(filename, 'r') as file:
                lines = file.readlines()

                for line in lines:
                    student_info = line.strip().split(',')
                    name = student_info[0]
                    record = student_info[1:]
                    self.records_dict[name] = record
        except FileNotFoundError:
            print("File not found!")

    def get_records(self, student):
        if student in self.records_dict:
            return self.records_dict[student]
        else:
            return "No record found!"

    def insert_record(self, info):
        name = info[0]
        record = info[1:]
        self.records_dict[name] = record

    def compute_gpa(self, student):
        if student in self.records_dict:
            record = self.records_dict[student]
            total_credit_hours = 16  # Assuming 4 courses with 4 credit hours each
            total_grade_points = 0

            for grade in record[2:]:
                if grade in self.gpa_scale:
                    total_grade_points += self.gpa_scale[grade]

            gpa = total_grade_points / total_credit_hours
            return gpa
        else:
            return "No record found!"


# Create a Records instance
records = Records("records.csv")

# Get records for a student
student_name = "Jason"
print("Records for", student_name + ":", records.get_records(student_name))

# Insert a record for a new student
new_student_record = ['Michael', 'Physics', 'Fresher', 'C', 'B+', 'A-', 'B']
records.insert_record(new_student_record)

# Compute GPA for a student
student_name = "Jason"
gpa = records.compute_gpa(student_name)
print("GPA for", student_name + ":", gpa)

# Compute GPA for a student with no record
student_name = "Alice"
gpa = records.compute_gpa(student_name)
print("GPA for", student_name + ":", gpa)

#3
#DECK OF CARDS
import random

class Card:
    def __init__(self, suit, value):
        self.suit = suit
        self.value = value

    def __str__(self):
        return f"{self.value} of {self.suit}"

class Deck:
    def __init__(self):
        suits = ["Hearts", "Diamonds", "Clubs", "Spades"]
        values = ["A", "2", "3", "4", "5", "6", "7", "8", "9", "10", "J", "Q", "K"]
        self.cards = [Card(suit, value) for suit in suits for value in values]

    def __str__(self):
        return f"Deck of {self.count()} cards"

    def count(self):
        return len(self.cards)

    def deal(self):
        if self.count() == 0:
            return None
        return self.cards.pop()

    def shuffle(self):
        if self.count() < 52:
            raise ValueError("Only full decks can be shuffled")
        random.shuffle(self.cards)

deck = Deck()


print(deck)

deck.shuffle()


print(deck)

card = deck.deal()
print(card)

print(deck.count())

#4
class BankAccount:
    minimum_balance = 1000

    def __init__(self, account_number, initial_balance):
        self.account_number = account_number
        self.balance = initial_balance

    def deposit(self, amount):
        self.balance += amount
        print("Amount deposited:", amount)
        self.print_balance()

    def withdraw(self, amount):
        if self.balance - amount >= self.minimum_balance:
            self.balance -= amount
            print("Amount withdrawn:", amount)
            self.print_balance()
        else:
            print("Insufficient balance to withdraw amount", amount)
            self.print_balance()

    def print_balance(self):
        print("Current balance:", self.balance)


# Create a BankAccount instance
account = BankAccount("1234567890", 5000)

# Perform bank transactions
account.deposit(2000)
account.withdraw(1500)
account.withdraw(5000)

